package cn.dg32z.lon.commands.sub;

import cn.dg32z.libs.chengzhiya.task.mhdfscheduler.scheduler.MHDFScheduler;
import cn.dg32z.libs.com.github.retrooper.packetevents.manager.server.ServerVersion;
import cn.dg32z.libs.com.github.retrooper.packetevents.protocol.entity.type.EntityTypes;
import cn.dg32z.libs.com.github.retrooper.packetevents.wrapper.play.server.WrapperPlayServerHeldItemChange;
import cn.dg32z.libs.org.jetbrains.annotations.NotNull;
import cn.dg32z.lon.LonAntiCheat;
import cn.dg32z.lon.PluginLoader;
import cn.dg32z.lon.checks.impl.combat.killaura.KillAuraG;
import cn.dg32z.lon.commands.AbstractCommand;
import cn.dg32z.lon.player.PlayerData;
import cn.dg32z.lon.utils.data.packetentity.PacketEntity;
import cn.dg32z.lon.utils.nmsutil.NMSUtils;
import java.util.Collections;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ThreadLocalRandom;
import java.util.stream.Collectors;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.util.Vector;

/* loaded from: cn_dg32z_lon_commands_sub.jar:cn/dg32z/lon/commands/sub/Mitigate.class */
public final class Mitigate extends AbstractCommand {
    private static final Map<String, MitigationType> TYPES;
    public static final Set<Entity> teleport_entity = new HashSet();
    public static Set<Entity> violationMap = new HashSet();

    @FunctionalInterface
    /* loaded from: cn_dg32z_lon_commands_sub.jar:cn/dg32z/lon/commands/sub/Mitigate$MitigationType.class */
    private interface MitigationType {
        void execute(PlayerData playerData, CommandSender commandSender, Player player, String[] strArr);
    }

    static {
        Map<String, MitigationType> types = new LinkedHashMap<>();
        types.put("damage", (data, sender, target, args) -> {
            data.addDamageReducePlayer();
            sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target, "commands.mitigate.types.damage.message"));
        });
        types.put("resetitem", (data2, sender2, target2, args2) -> {
            NMSUtils.resetItemUsage(target2);
            sender2.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target2, "commands.mitigate.types.reset-item.message"));
        });
        MitigationType knockbackAction = (data3, sender3, target3, args3) -> {
            double x = PluginLoader.INSTANCE.getConfigManager().getConfig().getDoubleElse("knock-back.x", 0.75d);
            double y = PluginLoader.INSTANCE.getConfigManager().getConfig().getDoubleElse("knock-back.y", 0.5d);
            double z = PluginLoader.INSTANCE.getConfigManager().getConfig().getDoubleElse("knock-back.z", 0.75d);
            target3.setVelocity(new Vector(x, y, z));
            sender3.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target3, "commands.mitigate.types.knock-back.message"));
        };
        types.put("knockback", knockbackAction);
        types.put("kb", knockbackAction);
        types.put("rotate", (data4, sender4, target4, args4) -> {
            data4.randomiseAim(target4, target4.getLocation());
            sender4.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target4, "commands.mitigate.types.rotate.message"));
        });
        types.put("shuffle", (data5, sender5, target5, args5) -> {
            int randomSlot = ThreadLocalRandom.current().nextInt(9);
            WrapperPlayServerHeldItemChange slotPacket = new WrapperPlayServerHeldItemChange(randomSlot);
            data5.user.writePacket(slotPacket);
            data5.packetStateData.lastSlotSelected = randomSlot;
            data5.getInventory().inventory.selected = randomSlot;
            data5.getInventory().requiresRefresh = true;
            data5.packetStateData.setSlowedByUsingItem(false);
            if (data5.bukkitPlayer != null) {
                data5.bukkitPlayer.updateInventory();
                data5.bukkitPlayer.getInventory().setHeldItemSlot(randomSlot);
            }
            NMSUtils.resetItemUsage(target5);
            data5.user.flushPackets();
            sender5.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target5, "commands.mitigate.types.shuffle.message").replace("%slot%", String.valueOf(randomSlot)));
        });
        types.put("food", (data6, sender6, target6, args6) -> {
            int original = target6.getFoodLevel();
            target6.setFoodLevel(0);
            MHDFScheduler.getAsyncScheduler().runTaskLater(LonAntiCheat.getInstance(), task -> {
                if (target6.isOnline()) {
                    target6.setFoodLevel(original);
                }
            }, 20L);
            sender6.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target6, "commands.mitigate.types.food.message"));
        });
        types.put("resync", (data7, sender7, target7, args7) -> {
            data7.resyncPose();
            sender7.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target7, "commands.mitigate.types.resync.message"));
        });
        types.put("killaura", (data8, sender8, target8, args8) -> {
            if (data8.target == null) {
                return;
            }
            PacketEntity targetEntity = data8.getTarget();
            if (targetEntity == null || targetEntity.isDead || targetEntity.getType() != EntityTypes.PLAYER) {
                sender8.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target8, "commands.mitigate.types.killaura.not-target"));
                return;
            }
            Entity player = Bukkit.getPlayer(targetEntity.getUuid());
            Location originalLoc = player.getLocation().clone();
            Vector direction = target8.getLocation().getDirection().normalize();
            Location behindLoc = target8.getLocation().add(direction.multiply(-1.5d));
            behindLoc.setY(target8.getLocation().getY() + 0.85d);
            behindLoc.setYaw(target8.getLocation().getYaw());
            if (LonAntiCheat.getInstance().getPacketEventsManager().getServerVersion().isNewerThanOrEquals(ServerVersion.V_1_15)) {
                player.teleportAsync(behindLoc);
            } else {
                player.teleport(behindLoc);
            }
            teleport_entity.add(player);
            sender8.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(player, "commands.mitigate.types.killaura.message").replace("%target%", target8.getName()));
            MHDFScheduler.getGlobalRegionScheduler().runTaskLater(LonAntiCheat.getInstance(), task -> {
                if (teleport_entity.contains(player)) {
                    if (LonAntiCheat.getInstance().getPacketEventsManager().getServerVersion().isNewerThanOrEquals(ServerVersion.V_1_15)) {
                        player.teleportAsync(originalLoc);
                    } else {
                        player.teleport(originalLoc);
                    }
                    sender8.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(player, "commands.mitigate.types.killaura.pull-back").replace("%target%", target8.getName()));
                    teleport_entity.remove(player);
                    if (violationMap.contains(player)) {
                        MHDFScheduler.getAsyncScheduler().runTask(LonAntiCheat.getInstance(), a -> {
                            if (data8.getCheckManger().getPacketCheck(KillAuraG.class) != null) {
                                data8.getCheckManger().getPacketCheck(KillAuraG.class).flagAndAlert("impossible attack?");
                                violationMap.remove(player);
                                sender8.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(player, "commands.mitigate.types.killaura.attacked").replace("%target%", target8.getName()));
                            }
                        });
                    }
                }
            }, PluginLoader.INSTANCE.getConfigManager().getConfig().getIntElse("commands.mitigate.types.killaura.tick", 10));
        });
        TYPES = Collections.unmodifiableMap(types);
    }

    public Mitigate() {
        super("mitigate", "lonac.commands.mitigate", false);
    }

    public void execute(@NotNull CommandSender sender, @NotNull String label, @NotNull String[] args) {
        String stringElse;
        if (args.length < 1) {
            sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("commands.mitigate.usage"));
            return;
        }
        String playerName = args[0];
        Player target = Bukkit.getPlayer(playerName);
        if (target == null) {
            sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("not-found").replace("%player%", playerName));
            return;
        }
        PlayerData data = PluginLoader.INSTANCE.getPlayerDataManager().getPlayer(target);
        if (data == null) {
            sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target, "not-data-user"));
            return;
        }
        if (args.length >= 2) {
            stringElse = args[1].toLowerCase();
        } else {
            stringElse = PluginLoader.INSTANCE.getConfigManager().getConfig().getStringElse("commands.mitigate.default-type", "damage");
        }
        String typeName = stringElse;
        MitigationType mitigation = TYPES.get(typeName);
        if (mitigation == null) {
            sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("commands.mitigate.invalid-type").replace("%type%", typeName));
        } else if (!sender.hasPermission("lonac.commands.mitigate." + typeName)) {
            sender.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("no-permission"));
        } else {
            mitigation.execute(data, sender, target, args);
        }
    }

    public List<String> tabCompleter(@NotNull CommandSender sender, @NotNull String label, @NotNull String[] args) {
        if (args.length == 1) {
            String partial = args[0].toLowerCase();
            return (List) Bukkit.getOnlinePlayers().stream().map((v0) -> {
                return v0.getName();
            }).filter(name -> {
                return name.toLowerCase().startsWith(partial);
            }).collect(Collectors.toList());
        }
        if (args.length == 2) {
            String partial2 = args[1].toLowerCase();
            return (List) TYPES.keySet().stream().filter(type -> {
                return type.startsWith(partial2);
            }).filter(type2 -> {
                return sender.hasPermission("lonac.commands.mitigate." + type2);
            }).collect(Collectors.toList());
        }
        return Collections.emptyList();
    }
}
